/*
	Simple TCP SOCKET INHERITING CHILD PROCESS
*/
#include<stdio.h>
#include<unistd.h>
#include<io.h>
#include<winsock2.h>

#define SERVER "127.0.0.1"	//ip address of udp server
#define BUFLEN 512	//Max length of buffer
#define PORT 8888	//The port on which to listen for incoming data

int main(int argc,char **p)
{
	int ps;
	int fd,ph;
	//HANDLE prnt;
	HANDLE targHandle;
	char buf[BUFLEN];
	WSADATA wsa;
	char rsp[] = "SOCKYOU"; // used to validate recieved data
//	const char *str = "Second string to be written to a file.\n";

	if (argc != 4) {
		printf("ERROR: Bad argument count (%d), exiting.\n", argc);
		return 1;
	} // p[1] has our socket number in it now p[2] our file handle

	printf("\nCHILD: Initialising Winsock (WSAStartup)... ");
	if (WSAStartup(MAKEWORD(2,2),&wsa) != 0)
	{
		printf("CHILD: Failed. Error Code : %d",WSAGetLastError());
		exit(EXIT_FAILURE);
	}
	printf("Winsock Initialized in child process.\n");
	printf("CHILD: socket number received on commandline from parent was - %s\n", p[1]);
	printf("CHILD: file descriptor number received on commandline from parent was - %s\n", p[2]);
	ps = atoi(p[1]);
	fd = atoi(p[2]);
	ph = atoi(p[3]);
	printf("CHILD: writing to fd using file handle integer - %d\n", fd);
//	if (write(fd, str, strlen(str)) > 1) {
//		printf("CHILD: fd inherited and written successfully.\n");
//	} else {
//		printf("CHILD: fd inherited handle write failed.\n");
//	}
    char DataBuffer2[] = "Other test data to write to the file.";
    DWORD dwBytesToWrite = (DWORD)strlen(DataBuffer2);
    DWORD dwBytesWritten = 0;
    BOOL bErrorFlag = FALSE;
    HANDLE hFile;

    printf(TEXT("CHILD: Writing %ld bytes to %s.\n"), dwBytesToWrite, "fhtest.txt");

    hFile = (HANDLE)fd;

    bErrorFlag = WriteFile( 
                    hFile, //&fd,           // open file handle
                    DataBuffer2,      // start of data to write
                    dwBytesToWrite,  // number of bytes to write
                    &dwBytesWritten, // number of bytes that were written
                    NULL);            // no overlapped structure

    if (FALSE == bErrorFlag)
    {
        printf("CHILD: ERROR - Unable to write to file.\n");
    }
    else
    {
        if (dwBytesWritten != dwBytesToWrite)
        {
            // This is an error because a synchronous write that results in
            // success (WriteFile returns TRUE) should write all data as
            // requested. This would not necessarily be the case for
            // asynchronous writes.
            printf("CHILD: Error - dwBytesWritten != dwBytesToWrite\n");
        }
        else
        {
            printf("CHILD: Wrote %ld bytes to %s successfully.\n", dwBytesWritten, "fhtest.txt");
        }
    }

	printf("CHILD: calling (blocking) recv() using socket handle integer - %d\n", ps);
	//clear the buffer by filling null, it might have previously received data
	memset(buf,'\0', BUFLEN);
	//try to receive some data, this is a blocking call
	if (recv(ps, buf, BUFLEN, 0) == SOCKET_ERROR)
	{
		printf("CHILD: recv() on inherited TCP port failed with error code : %d\n" , WSAGetLastError());
		//printf("CHILD: calling WSACleanup and exiting to parent (press key to exit parent).\n");
		//WSACleanup();
		//exit(EXIT_FAILURE);
	}
	// if the test succeeded we should have the string SOCKYOU in buf but we check. it..
	if ((strlen(buf) > 1) && (strcmp(buf, rsp) == 0)) {
		printf("\nCHILD: TCP inherited Socket data received was - %s\n", buf);
		printf("\nCHILD: TCP Socket inheritance test was successful.\n");
	} else {
		printf("CHILD: TCP Socket inheritance test has failed !\n");
		printf("CHILD: attempting to use DuplicateHandle to duplicate the socket.\n");
		/* MS DOCS are contradictory about this. The winsock page seems to indicate it will work, but the DuplicateHandle 
		documentation says you shouldn't do it and that the handle may not be recognized and that it may mess up winsock
		reference counting. We'll give it a try to find out who's full of crap.. since we are inheriting it anyway
		maybe we are the lucky special case that will work ?? who knows, all depende on ROS and its plumbing. */
		/* first we need to open a handle to our parent (who's yer daddy) */
		/* now we can try to duplicate the socket handle and read from it */
		if (DuplicateHandle(&ph, &ps, GetCurrentProcess(), &targHandle, 0, FALSE, DUPLICATE_SAME_ACCESS)) {
			printf("CHILD: DuplicateHandle() call reported success, try reading our duplicate handle.\n");
			memset(buf,'\0', BUFLEN);
			//try to receive some data, this is a blocking call
			if (recv(ps, buf, BUFLEN, 0) == SOCKET_ERROR)
			{
				printf("CHILD: recv() on duplicated TCP port failed with error code : %d\n" , WSAGetLastError());
			} else {
				// if the test succeeded we should have the string SOCKYOU in buf but we check. it..
				if ((strlen(buf) > 1) && (strcmp(buf, rsp) == 0)) {
					printf("\nCHILD: TCP duplicated Socket data received was - %s\n", buf);
					printf("\nCHILD: TCP Socket duplicated socket test was successful.\n");
				}
			}		
		} else {
			printf("CHILD: DuplicateHandle() call reported failure, we are done trying...\n");
		}
	}
        printf("Press <any key> to exit child.\n");
	getchar();
	printf("CHILD: calling WSACleanup and exiting to parent.\n");
	WSACleanup();
	return 0;
}
