/*
	Simple udp client
*/
#include<stdio.h>
#include<winsock2.h>

 /* pragma comment(lib,"ws2_32.lib") //Winsock Library */

#define SERVER "127.0.0.1"	//ip address of udp server
#define BUFLEN 512	//Max length of buffer
#define PORT 8888	//The port on which to listen for incoming data

int main(void)
{
	char hdr_mssg[BUFLEN];
	struct sockaddr_in si_other;
	int s, ps, slen=sizeof(si_other); // ps used for inherited parent socket
	char cmd_mssg[BUFLEN];	
	char buf[BUFLEN];
	WSADATA wsa;
	WSABUF ws_buf[2];
	char message[BUFLEN];
	DWORD BytesSent, dwFlags;
	char cmd1[] = "SOCKME";
	char cmd2[] = "EXIT";
	char rsp[] = "SOCKYOU";
	char * ourSock; // used to pluck socket number from response to SOCKME command

	//Initialise winsock
	printf("\nCLIENT: Initialising Winsock...\n");
	if (WSAStartup(MAKEWORD(2,2),&wsa) != 0)
	{
		printf("CLIENT: Failed. Error Code : %d",WSAGetLastError());
		exit(EXIT_FAILURE);
	}
	printf("CLIENT: Initialized.\n");
	
	//create socket
	if ( (s=socket(AF_INET, SOCK_DGRAM, IPPROTO_UDP)) == SOCKET_ERROR)
	{
		printf("CLIENT: socket() failed with error code : %d\n" , WSAGetLastError());
		exit(EXIT_FAILURE);
	}
	
	//setup address structure
	memset((char *) &si_other, 0, sizeof(si_other));
	si_other.sin_family = AF_INET;
	si_other.sin_port = htons(PORT);
	si_other.sin_addr.S_un.S_addr = inet_addr(SERVER);
	
	// imitate the bufferarray srutcture used by SAMBA for packet construction
	sprintf(hdr_mssg, "|SRC_ID||SESSN_ID|");
	sprintf(cmd_mssg, "|CMD_ID||CMD_PARM|");	
	ws_buf[1].buf = hdr_mssg;
	ws_buf[1].len = strlen(hdr_mssg); //0;	
	ws_buf[2].buf = cmd_mssg;	
	ws_buf[2].len = strlen(cmd_mssg); //0;	
	//start communication
	while(1)
	{
		printf("CLIENT: Enter message : \n");
		gets(message);
		ws_buf[0].buf = message;			
		ws_buf[0].len = strlen(message);	// sent fake header first, but ROS currently sends only first item so cmd first
		dwFlags = 0;
		if ( connect(s, (struct sockaddr *) &si_other, slen) == SOCKET_ERROR)
		{
			printf("CLIENT: connect() failed with error code : %d\n" , WSAGetLastError());
			exit(EXIT_FAILURE);
		}
		
		slen=sizeof(si_other);
		//setup address structure
		memset((char *) &si_other, 0, sizeof(si_other));
		si_other.sin_family = AF_INET;
		si_other.sin_port = htons(PORT);
		si_other.sin_addr.S_un.S_addr = inet_addr(SERVER);	

//		if (sendto(s, message, strlen(message) , 0 , NULL, 0) == SOCKET_ERROR)
		if (WSASendTo(s, ws_buf, 3, &BytesSent, dwFlags , (struct sockaddr *) &si_other, slen, NULL, NULL) == SOCKET_ERROR)			
		{
			printf("CLIENT: sendto() failed with error code : %d\n" , WSAGetLastError());
			exit(EXIT_FAILURE);
		}
		
		//receive a reply and print it
		//clear the buffer by filling null, it might have previously received data
		memset(buf,'\0', BUFLEN);
		//try to receive some data, this is a blocking call
		if (recvfrom(s, buf, BUFLEN, 0, (struct sockaddr *) &si_other, &slen) == SOCKET_ERROR)
		{
			printf("CLIENT: recvfrom() failed with error code : %d\n" , WSAGetLastError());
			exit(EXIT_FAILURE);
		}
		
		printf("CLIENT: received - %s\n",buf);
		// all commands send back something, but some of them require post processing as well. What we do going forward depends on the command
		// as well as the response. We only respond to two commands EXIT and SOCKME in this test application
		if (strcmp(message, cmd1) == 0) { // SOCKME command given by user, reply should have our inherited socket number for recv
			ourSock = &buf[7];
			printf("CLIENT: socket returned was - %s\n", ourSock);
			ps = atoi(ourSock);
			printf("CLIENT: calling recv on integer version of socket - %d\n", ps);
			//clear the buffer by filling null, it might have previously received data
			memset(buf,'\0', BUFLEN);
			//try to receive some data, this is a blocking call
			if (recv(ps, buf, BUFLEN, 0) == SOCKET_ERROR)
			{
				printf("CLIENT: recv() on inherited TCP port failed with error code : %d\n" , WSAGetLastError());
				exit(EXIT_FAILURE);
			}
			// if the test succeeded we should have the string SOCKYOU in buf
			if ((strlen(buf) > 1) && (strcmp(buf, rsp) == 0)) {
				printf("CLIENT: TCP inherited Socket received - %s\n", buf);
				puts("CLIENT: TCP Socket inheritance test was successful.");
				fflush(stdout);
			} else {
				puts("CLIENT: TCP Socket inheritance test has failed !");
				fflush(stdout);
			}
		}
		if ((strcmp(message, cmd2) == 0)) { // EXIT command issued and echoed back so exit
			puts("CLIENT: RECEIVED EXIT command, exiting..");
			return 0;
		}
	}

	closesocket(s);
	WSACleanup();

	return 0;
}
